local Gnoll = _G.Gnoll
local GL = Gnoll.Locale
local GLW = Gnoll.WoWLocale
local GD = Gnoll.Data

function FavAdd(name,art,k,i,b)
	Gnoll.DB["favoriten"][art..k..i..b] = {name, {art,k,i,b}}
	ItemFrameFavButton:SetText("- Favorite")
	ItemFrameFavButton:SetScript("OnClick", function(self, button) 
	FavDel(name,art,k,i,b) 
	end)	
end

function FavDel(name,art,k,i,b)
	Gnoll.DB["favoriten"][art..k..i..b] = nil
	ItemFrameFavButton:SetText("+ Favorite")
	ItemFrameFavButton:SetScript("OnClick", function(self, button)
	FavAdd(name,art,k,i,b) 
	end)	
end

function QuickSelect(art,kontinent,instanz,boss)	--- JumpTo
	Hauptfenster:Show()
	WishFrame:Hide()
	ItemFrame:Show()
	Gnoll["tmp"]["abfrage"] = { art, kontinent, instanz, boss }
	LootAbfrageStart(art,kontinent,instanz,boss)
end

local function OnEnterButton(self,link)
		GameTooltip:SetOwner(self, "ANCHOR_NONE")
		GameTooltip:SetPoint("BOTTOM", self, "LEFT", 0, 5)
		if link ~= nil then
			GameTooltip:SetHyperlink(link)
		end
end

local function OnLeaveButton(self)
	GameTooltip:Hide()
end

function CreateWishButtons(Frame)
	WishButtons = { { } }
	for i=1, 30 do
		if i <= 10 then
			abstand = i*40
			spalte = 55
		elseif i >= 11 and i <= 20 then 
			 abstand = (i-10) *40
			 spalte = 250+55
		elseif i >= 21 and i <= 30 then
			 abstand = (i-20) *40
			 spalte = 500+55
		end
			
		WishButtons[i] = CreateFrame("Button", nil, Frame)
		button = WishButtons[i]
		
		button:SetPoint("Topleft", Frame, 0+spalte-32, 0-abstand)
		button:SetWidth(232)
		button:SetHeight(32)
			
		local fo = button:CreateFontString()
			fo:SetFont("Fonts/FRIZQT__.TTF",11)
			fo:SetPoint("LEFT", button, "LEFT", 34,8)
			button:SetFontString(fo)
		
		local ntex = button:CreateTexture()
		ntex:SetTexture("Interface/FrameGeneral/UI-Background-Marble")
		ntex:SetAlpha(0.8) 
		ntex:SetAllPoints()
		button:SetNormalTexture(ntex)
		button:SetScript("OnLeave", OnLeaveButton)
		button:RegisterForClicks("AnyDown")
		button:Hide()
		
		button.icon = CreateFrame("Button", nil, button)
		icon = button.icon
		
		icon:SetPoint("Left", button, 0, 0)
		icon:SetWidth(32)
		icon:SetHeight(32)
		
		local itex = icon:CreateTexture()
		itex:SetTexture("Interface\ICONS\Ability_Creature_Cursed_03")
		itex:SetAllPoints()
		icon:SetNormalTexture(itex)
		icon:Show()
		
		local fo = icon:CreateFontString()
		fo:SetFont("Fonts/FRIZQT__.TTF",9)
		fo:SetPoint("LEFT", button, "LEFT", 34,-10)
		icon:SetFontString(fo)
		
		
	end
end

function ClearWishButtons()
	for i=1,30 do
		WishButtons[i]:Hide()
	end
end

local function OnClickWish(self,arg1,arg2)
	local wl = Gnoll["tmp"]["wish"][2][1]
	local id = Gnoll["tmp"]["wish"][2][3]
	if arg1 == "delete" then
		Gnoll["DB"]["wunschliste"][wl][id] = nil
		ChatFrame1:AddMessage("[Gnoll] "..Gnoll["tmp"]["wish"][1][1].." "..GL["ItemWishlistDEL"])
	elseif arg1 == "move" and arg2 ~= "move" then
		Gnoll["DB"]["wunschliste"][arg2][id] = Gnoll["DB"]["wunschliste"][wl][id]
		Gnoll["DB"]["wunschliste"][wl][id] = nil
		ChatFrame1:AddMessage("[Gnoll] "..string.format(GL["%s moved from %s to %s"],Gnoll["tmp"]["wish"][1][1],Gnoll["DB"]["wunschliste"]["names"][Gnoll["tmp"]["wish"][2][1]],Gnoll["DB"]["wunschliste"]["names"][arg2]))
	end
end

local function initializeWishDropDown(self, level, menuList)
	local info = UIDropDownMenu_CreateInfo()
	if level == 1 or menuList == nil then

		info.text, info.value, info.func, info.menuList,info.hasArrow, info.arg1, info.arg2 = GL["Remove"], "Remove", OnClickWish,"wl",false,"delete",k
		UIDropDownMenu_AddButton(info, level)
		info.text, info.value, info.func, info.menuList,info.hasArrow, info.arg1, info.arg2 = GL["Move"], "move", OnClickWish,"wl",true, "move", "move"
		UIDropDownMenu_AddButton(info, level)

	elseif level == 2 or menuList == "wl" then
		for k,v in pairs(Gnoll["DB"]["wunschliste"]["names"]) do   
		   info.text, info.value, info.func, info.menuList, info.hasArrow, info.arg1, info.arg2 = v,v, OnClickWish, nil, false, "move", k
		   UIDropDownMenu_AddButton(info, level)
	    end
	end
end

function ShowWishPage(self,button,arg2,wl)
	if type(wl) == "nil" then wl = 1 end
	local WishList = Gnoll["DB"]["wunschliste"][wl]
	local itemTable = { }	
		
	local count = 0
	for k,v in pairs(WishList) do  -- K = itemid V =  Table
		count = count + 1
		itemTable[count] = { }
		itemTable[count]["id"] = k
		itemTable[count]["table"] = v
	end

		if count ~= 0 then 
		local seite = -1
		local maxsites = math.ceil(#itemTable / 30)
		if arg2 == nil then 
			seite = 1 
		else 
			if arg2 > maxsites then
				seite = maxsites
			elseif arg2 < 1 then
				seite = 1
			else
				seite = arg2 
			end
		end 
		local start = 30 * seite -29
		local ende = 30 * seite
		
		WishPagetext:SetText(string.format("|cFFFFFFFF"..GL["Page %d of %d"], seite,maxsites))
		
		
		---Buttons mit Funktionen belegen
		WishSeiteLinks:SetScript("OnMouseDown", function(self, button,arg2)
			ShowWishPage(self,button, seite -1)
		end)
		WishSeiteRechts:SetScript("OnMouseDown", function(self, button,arg2)
			ShowWishPage(self, button, seite +1)
		end)
		WishFrame:SetScript("OnMouseWheel", function(self, delta)
			ShowWishPage(self, button, seite - delta)
		end)
		
		if ende >= count then -- more Items ?
			WishSeiteRechts:Hide()
		else
			WishSeiteRechts:Show()
		end
		
		if seite > 1 then 
			WishSeiteLinks:Show()
		else
			WishSeiteLinks:Hide()
		end
		
		if count < ende then -- not enough items :(
			ende = count
		end
		
		local buttonid = 1
		for i = start, ende do
			 local id = 0
			 local tmp = 0
			 
			 if i >= 31 then  --buttonid wird nicht übermittelt also ein kleiner workaround
				tmp = math.floor(i / 30)
				id = i - tmp*30
			 else
				id = i
			 end
		
			WishButtons[buttonid]:Show()
			WishButtons[buttonid]:SetAlpha(1) 
			--Inhalt
			local _, _, Farbe = string.find(itemTable[i]["table"][1],"|?c?f?f?(%x*)")
			local _, _, ItemName = string.find(itemTable[i]["table"][1],"|?h?%[?([^%[%]]*)%]")
			if strlen(ItemName) > 30 then ItemName = strsub(ItemName,0,30).."..." end 
			WishButtons[buttonid]:SetText("|cff"..Farbe..ItemName)
			--Tooltip
			WishButtons[buttonid]:SetScript("OnEnter", function(self,arg1)
				OnEnterButton(self,itemTable[i]["table"][1])
				end)
			--Icon
			texture = GetItemIcon(itemTable[i]["id"])
			local kontinent = tonumber(itemTable[i]["table"][3])
			local instanz  = tonumber(itemTable[i]["table"][4])
			local boss = tonumber(itemTable[i]["table"][5])
			local art = itemTable[i]["table"][2]
			local ausgabe = ""

			WishButtons[buttonid].icon:SetNormalTexture(texture)
			WishButtons[buttonid]:SetScript("OnClick", function(self, button)
					 if button == "LeftButton" then 
						 if(IsShiftKeyDown()) then
							 local e = DEFAULT_CHAT_FRAME.editBox
							 local tmp = e:GetText()
							
							 ChatEdit_ActivateChat(e)
							 e:SetText(tmp .. itemTable[i]["table"][1])
						
						 elseif(IsControlKeyDown()) then
							DressUpItemLink(itemTable[i]["table"][1])
						 end
					elseif button == "RightButton" then
						local kontinent =  tonumber(itemTable[i]["table"][3])
						local instanz  =  tonumber(itemTable[i]["table"][4])
						local boss  = tonumber(itemTable[i]["table"][5])
				        local art = itemTable[i]["table"][2]

				        Gnoll["tmp"]["wish"] = { }
						Gnoll["tmp"]["wish"][1] = itemTable[i]["table"]
						Gnoll["tmp"]["wish"][2] = {wl,i,itemTable[i]["id"]}
						
						UIDropDownMenu_Initialize(WishDropDown, initializeWishDropDown, "MENU")
						ToggleDropDownMenu(1, nil, WishDropDown, self, -20, 0)

					end 
				 end)
				 
				WishButtons[buttonid].icon:SetScript("OnClick", function(self, delta)
					QuickSelect(art,kontinent,instanz,boss)
				end)
				 
			---Herkunft des Item
				if art == "modul" then	-- Modulwishlist
					bossaus = GD["ModulData"][kontinent][instanz][boss]
					ini = GD["Modul"][kontinent][instanz]
					if string.find(bossaus,"f###") ~= nil then
						local _, start = string.find(bossaus,"f###")
						local id = string.sub(bossaus, start+1)
						bossaus = GetFactionInfoByID(id)
					elseif string.find(bossaus,"e###") ~= nil then
						local _, start = string.find(bossaus,"e###")
						local id = string.sub(bossaus, start+1)
						bossaus = EJ_GetEncounterInfo(id)
					end
					ausgabe = bossaus.." - "..ini
					if strlen(ausgabe) > 30 then ausgabe = strsub(ausgabe,0,30).."..." end
					WishButtons[buttonid].icon:SetText(ausgabe)

				elseif art == "default" then 	-- "normale Wishlist"
					if GD["MapIDS"][kontinent][instanz] == GL["World Bosses"] then
						ini = GD["MapIDS"][kontinent][instanz]
					else
						ini = GetMapNameByID(GD["MapIDS"][kontinent][instanz])
					end
					bossaus = EJ_GetEncounterInfo(GD["Bosse"][kontinent][instanz][boss])
					ausgabe = bossaus.." - "..ini
					if strlen(ausgabe) > 30 then ausgabe = strsub(ausgabe,0,30).."..." end
					WishButtons[buttonid].icon:SetText(ausgabe)
				
				elseif art  == "addon" then
					ini = GD["AddonModulData"][kontinent][instanz]
					WishButtons[buttonid].icon:SetText(ini)
				end
			
			buttonid = buttonid +1
		end
		if buttonid < 30 then -- not enough items :(
			for i = buttonid, 30 do
				WishButtons[buttonid]:Hide()
				buttonid = buttonid +1
			end
		end
	else
		ClearWishButtons()
	end
end  