﻿hordecolor = "|cFF".."C81C1C" -- Gnoll.lua if frac == "Alliance" and
allianzcolor = "|cFF".."1565c0"-- Glo..lua if frac == "Horde" and
 
sometimeseventcolor = "|cFF".."FFFF00"
everytimeeventcolor = "|cFF".."FF9900"
artifactcolor = "|cFF".."e6cc80"
legendarycolor = "|cFF".."ff8000"
whitecolor = "|cFF".."FFFFFF"

worldeventscolor = "|cFF".."FFFF00"
collectiblescolor = "|cFF".."FFEE00"
factionscolor = "|cFF".."FFDD00"
pvpcolor = "|cFF".."FFCC00"
setscolor = "|cFF".."FFBB00"
professionscolor = "|cFF".."FFAA00"

kriegercolor = "|cFF".."C79C6E"
paladincolor = "|cFF".."F58CBA"
jaegercolor = "|cFF".."ABD473"
schurkecolor = "|cFF".."FFF569"
priestercolor = "|cFF".."FFFFFF"
todesrittercolor = "|cFF".."C41F3B"
schamanecolor = "|cFF".."0070DE"
magiercolor = "|cFF".."69CCF0"
hexenmeistercolor = "|cFF".."9482C9"
moenchcolor = "|cFF".."00FF96"
druidecolor = "|cFF".."FF7D0A"
daemonenjaegercolor = "|cFF".."A330C9"

local Gnoll = _G.Gnoll
local GL = Gnoll.Locale
local GLW = Gnoll.WoWLocale


local Instanzen = { }
local MapIDS = { }
local Difficulty = { }
local Bosse = newtable(2)
local FactionDB = newtable(2)

	local ClassSpecs = {{71,72,73},{65,66,70},{253,254,255},{259,260,261},{256,257,258},{250,251,252},{262,263,264},{62,63,64},{265,266,267},{268,269,270},{102,103,104,105},{577,581}}
	local Addons = {"Classic","Burning Crusade","Wrath of the Lich King","Cataclysm","Mists of Pandaria","Warlords of Draenor","Legion"}

							-------------------- Classic:  --------------------
	Difficulty[1] = { {1,2},{1},{1},{1},{1},{1},{1},{1},{1,2},{1,2},{1,2},{1},{1},{1},{1},{1,2},{1},{1},{1},{1},{9},{9},{3},{9} }
	Instanzen[1] =  { 64,230,226,231,240,233,234,232,311,316,246,228,236,237,227,63,239,229,238,241,741,742,743,744 }
	MapIDS[1] =     { 764,699,680,691,749,760,761,750,871,874,898,704,765,687,688,756,692,721,690,686,696,755,717,766 }
							-------------------- Dungeons:  --------------------
	Bosse[1][1] = { 96,97,98,99,100 }										-- Burg Schattenfang
	Bosse[1][2] = { 402,403,404,405,406,407,408,409,410,411,412,413,414,415,416,417 }	-- Düsterbruch
	Bosse[1][3] = { 694,695,696,697 }										-- Flammenschlund
	Bosse[1][4] = { 419,420,421,418,422 }									-- Gnomeregan
	Bosse[1][5] = { 474,476,475,477,478,479,480,481 }						-- Höhlen des Wehklagens
	Bosse[1][6] = { 1142,433,1143,1146,1141 }								-- Hügel der Klingenhauer
	Bosse[1][7] = { 896,895,899,900,901 }									-- Kral der Klingenhauer
	Bosse[1][8] = { 423,424,425,427,428,429,430,431 }						-- Maraudon
	Bosse[1][9] = { 660,654,656 }											-- Scharlachrote Hallen
	Bosse[1][10] = { 688,671,674 }											-- Scharlachrotes Kloster
	Bosse[1][11] = { 659,663,665,666,684 }									-- Scholomance
	Bosse[1][12] = { 369,370,371,372,373,374,375,376,377,378,379,380,381,382,383,384,385,386,387 }	-- Schwarzfelstiefen
	Bosse[1][13] = { 443,445,--[[749,]]446,448,449,450,451,452,453,454,455,456 }					-- Stratholme
					-- Entfernte NPCs: Kommandant Malor (749)
	Bosse[1][14] = { 457,458,459,463 }										-- Tempel von Atal'Hakkar
	Bosse[1][15] = { 368,436,426,1145,447,1144,437,444 }					-- Tiefschwarze Grotte
	Bosse[1][16] = { 89,90,91,92,93 }										-- Todesminen
	Bosse[1][17] = { 467,469,--[[748,]]470,471,472,473 }					-- Uldaman
					-- Entfernte NPCs: Obsidianwächter (748)
	Bosse[1][18] = { 388,389,390,391,392,393,394,395,396 }					-- Untere Schwarzfelsspitze
	Bosse[1][19] = { 464,465,466 }											-- Verlies
	Bosse[1][20] = { --[[482,]]483,484,--[[485,]]486,487,489 }				-- Zul'Farrak
					-- Entfernte NPCs: Hydromantin Velratha (482), Theka der Märtyrer (485)
							-------------------- Raids:  --------------------
	Bosse[1][21] = { 1519,1520,1521,1522,1523,1524,1525,1526,1527,1528 }	-- Geschmolzener Kern
	Bosse[1][22] = { 1529,1530,1531,1532,1533,1534,1535,1536 }				-- Pechschwingenhort
	Bosse[1][23] = { 1537,1538,1539,1540,1541,1542 }						-- Ruinen von Ahn'Qiraj
	Bosse[1][24] = { 1543,1547,1544,1545,1548,1546,1549,1550,1551 }			-- Tempel von Ahn'Qiraj

							-------------------- Burning Crusade:  --------------------
	Difficulty[2] = { {1,2,24},{1,2},{1,2},{1,2},{1,2},{1,2},{1,2,24},{1,2},{1,2},{1,2,24},{1,2},{1,2,24},{1,2,24},{1,2},{1,2},{1,2,24},{4},{4},{4},{3},{4},{4},{4},{4} }
	Instanzen[2] =  { 254,247,256,257,261,248,250,258,253,255,252,260,249,262,251,259,749,746,748,745,747,750,751,752 }
	MapIDS[2] =     { 731,722,725,729,727,797,732,730,724,733,723,728,798,726,734,710,782,776,780,799,779,775,796,789 }
	Bosse[2][1] = { 548,549,550,551 }										-- Arkatraz
	Bosse[2][2] = { 523,524 }												-- Auchenaikrypta
	Bosse[2][3] = { 555,556,557 }											-- Blutkessel
	Bosse[2][4] = { 558,559,560,561,562 }									-- Botanika
	Bosse[2][5] = { 573,574,575 }											-- Dampfkammer
	Bosse[2][6] = { 527,528,529 }											-- Höllenfeuerbollwerk
	Bosse[2][7] = { 534,535,537 }											-- Managruft
	Bosse[2][8] = { 563,564,565 } -- Cache of the Legion?					-- Mechanar
	Bosse[2][9] = { 544,545,546,547 }										-- Schattenlabyrinth
	Bosse[2][10] = { 552,553,554}											-- Schwarze Morast
	Bosse[2][11] = { 541,543 }	-- Heroisch: Anzu							-- Sethekkhallen
	Bosse[2][12] = { 570,571,572 }											-- Sklavenunterkünfte
	Bosse[2][13] = { 530,531,532,533 }										-- Terrasse der Magister
	Bosse[2][14] = { 576,577,578,579 }										-- Tiefensumpf
	Bosse[2][15] = { 538,539,540 }											-- Vorgebirge des Alten Hügellands
	Bosse[2][16] = { 566,568,569 }											-- Zerschmetterten Hallen
							-------------------- Raids:  --------------------
	Bosse[2][17] = { 1573,1574,1575,1576 }									-- Das Auge = Festung der Stürme
	Bosse[2][18] = { 1564,1565 }											-- Gruuls Unterschlupf
	Bosse[2][19] = { 1567,1568,1569,1570,1571,1572 }						-- Höhle des Schlangenschreins
	Bosse[2][20] = { 1552,1553,1554,1555,1556,1558,1557,1559,1560,1561,1562,1563 }	-- Karazhan
	Bosse[2][21] = { 1566 }													-- Magtheridons Kammer
	Bosse[2][22] = { 1577,1578,1579,1580,1581 }								-- Die Schlacht um den Hyjal = Hyjalgipfel
	Bosse[2][23] = { 1582,1583,1584,1585,1586,1587,1588,1589,1590 }			-- Schwarze Tempel
	Bosse[2][24] = { 1591,1592,1593,1594,1595,1596 }						-- Sonnenbrunnenplateau

							-------------------- Wrath of the Lich King:  --------------------
	Difficulty[3] = { {1,2,24},{1,2},{1,2},{1,2},{1,2},{1,2,24},{1,2,24},{1,2,24},{1,2},{1,2},{1,2,24},{1,2},{1,2},{1,2},{1,2,24},{1,2},{3,4},{3,4},{3,5,4,6},{3,4},{3,4},{3,4},{3,5,4,6},{3,5,4,6},{3,4} }
	Instanzen[3] = 	{ 271,279,272,285,273,278,274,275,276,277,281,282,284,280,286,283,753,756,758,754,755,760,757,761,759 }
	MapIDS[3] = 	{ 522,521,533,523,534,602,530,525,603,526,520,528,542,601,524,536,532,527,604,535,531,718,543,609,529 }
	Bosse[3][1] = { 580,581,582,584 }										-- Ahn'kahet: Das Alte Königreich
	Bosse[3][2] = { 611,612,613,614 }										-- Das Ausmerzen von Stratholme
	Bosse[3][3] = { 585,586,587 }											-- Azjol-Nerub
	Bosse[3][4] = { 638,639,640 }											-- Burg Utgarde
	Bosse[3][5] = { 588,589,590,591 }										-- Feste Drak'Tharon
	Bosse[3][6] = { 608,609,610 }											-- Grube von Saron
	Bosse[3][7] = { 592,593,594,596 }										-- Gundrak
	Bosse[3][8] = { 597,598,599,600 }										-- Hallen der Blitze
	Bosse[3][9] = { 601,602,603 }											-- Hallen der Reflexionen
	Bosse[3][10] = { 604,605,606,607 }										-- Hallen des Steins
	Bosse[3][11] = { 618,619,620,621 }										-- Der Nexus
	Bosse[3][12] = { 622,623,624,625 }										-- Das Oculus
	Bosse[3][13] = { 634,635,636,637 }										-- Prüfung des Champions
	Bosse[3][14] = { 615,616 }												-- Die Seelenschmiede
	Bosse[3][15] = { 641,642,643,644 }										-- Turm Utgarde
	Bosse[3][16] = { 626,627,628,629,630,631,632 }							-- Die Violette Festung
							-------------------- Raids:  --------------------
	Bosse[3][17] = { 1597,1598,1599,1600 }									-- Archavons Kammer
	Bosse[3][18] = { 1617 }													-- Das Auge der Ewigkeit 
	Bosse[3][19] = { 1624,1625,1626,1628,1629,1630,1631,1632,1633,1634,1635,1636 }	-- Eiskronenzitadelle
	Bosse[3][20] = { 1601,1602,1603,1604,1605,1606,1607,1608,1609,1610,1611,1612,1613,1614,1615 }	-- Naxxramas
	Bosse[3][21] = { 1616 }													-- Obsidiansanktum
	Bosse[3][22] = { 1651 }													-- Onyxias Hort
	Bosse[3][23] = { 1618,1619,1621,1622,1623 }								-- Prüfung des Kreuzfahrers
	Bosse[3][24] = { 1652 }													-- Rubinsanktum
	Bosse[3][25] = { 1637,1638,1639,1640,1641,1642,1643,1644,1645,1646,1647,1648,1649,1650 }	-- Ulduar

							-------------------- Cataclysm:  --------------------
	Difficulty[4] = { {2},{1,2},{2,24},{1,2,24},{1,2},{1,2},{1,2,24},{2},{1,2,24},{1,2},{1,2,24},{1,2,24},{1,2},{1,2},{3,5,4,6},{3,5,4,6},{7,3,5,4,6},{3,5,4,6},{3,5,4,6},{3,5,4,6} }
	Instanzen[4] = 	{ 185,64,184,71,70,66,67,186,65,63,69,68,77,76,75,72,187,78,73,74 }
	MapIDS[4] = 	{ 816,764,820,757,759,753,768,819,767,756,747,769,781,793,752,758,824,800,754,773 }
	Bosse[4][1] = { 290,291,292 }											-- Brunnen der Ewigkeit
	Bosse[4][2] = { 96,97,98,99,100 }										-- Burg Schattenfang
	Bosse[4][3] = { 340,285,323,283,289 }									-- Endzeit
	Bosse[4][4] = { 131,132,133,134 }										-- Grim Batol
	Bosse[4][5] = { 124,125,126,127,128,129,130 }							-- Hallen des Ursprungs
	Bosse[4][6] = { 105,106,107,108,109 }									-- Schwarzfelshöhlen
	Bosse[4][7] = { 110,111,112,113 }										-- Der Steinerne Kern
	Bosse[4][8] = { 322,342,341 }											-- Stunde des Zwielichts
	Bosse[4][9] = { 101,102,103,104 }										-- Thron der Gezeiten
	Bosse[4][10] = { 89,90,91,92,93,95 }									-- Todesminen
	Bosse[4][11] = { 117,118,119,122 }										-- Die Verlorene Stadt der Tol'vir
	Bosse[4][12] = { 114,115,116 }											-- Vortexgipfel
	Bosse[4][13] = { 186,187,188,189,190,191 }								-- Zul'Aman
	Bosse[4][14] = { 175,176,177,178,179,180,181,184,185 }					-- Zul'Gurub
							-------------------- Raids:  --------------------
	Bosse[4][15] = { 139,140,339 }  										-- Baradinfestung
	Bosse[4][16] = { 156,157,158,167 }										-- Bastion des Zwielichts
	Bosse[4][17] = { 311,324,325,317,331,332,318,333 }						-- Drachenseele
	Bosse[4][18] = { 192,193,194,195,196,197,198 }							-- Feuerlande
	Bosse[4][19] = { 169,170,171,172,173,174 }								-- Pechschwingenabstieg
	Bosse[4][20] = { 154,155 }												-- Thron der Vier Winde

							-------------------- Mists of Pandaria:  --------------------
	Difficulty[5] = { {1,2},{1,2},{1,2},{1,2},{1,2},{1,2},{1,2},{1,2},{1,2},{7,3,5,4,6},{17,14,15,16},{7,3,5,4,6},{7,3,5,4,6},{7,3,5,4,6},{0} }
	Instanzen[5] = 	{ 324,302,321,311,316,246,312,313,303,330,369,317,320,362,322 }
	MapIDS[5] = 	{ 887,876,885,871,874,898,877,867,875,897,953,896,886,930,GL["World Bosses"] }
	Bosse[5][1] = { 693,738,692,727 }										-- Belagerung des Niuzaotempels
	Bosse[5][2] = { 668,669,670 }											-- Die Brauerei Sturmbräu
	Bosse[5][3] = { 708,690,698 }											-- Mogu'shanpalast
	Bosse[5][4] = { 660,654,656 }											-- Scharlachrote Hallen
	Bosse[5][5] = { 688,671,674 }											-- Scharlachrote Kloster
	Bosse[5][6] = { 659,663,665,666,684 }									-- Scholomance
	Bosse[5][7] = { 673,657,685,686 }										-- Shado-Pan Kloster
	Bosse[5][8] = { 672,664,658,335 }										-- Tempel der Jadeschlange
	Bosse[5][9] = { 655,675,676,649 }										-- Tor der Untergehenden Sonne
							-------------------- Raids:  --------------------
	Bosse[5][10] = { 745,744,713,741,737,743 }								-- Herz der Angst
	Bosse[5][11] = { 852,849,866,867,881,864,856,850,846,870,851,865,853,869 }		-- Schlacht um Ogrimmar	
	Bosse[5][12] = { 679,689,682,687,726,677 }								-- Mogu'shangewölbe
	Bosse[5][13] = { 683,742,729,709 }										-- Terrasse des Endlosen Frühlings
	Bosse[5][14] = { 827,819,816,825,821,828,818,820,824,817,829,832 }		-- Thron des Donners
	Bosse[5][15] = { 691,725,814,826,857,858,859,860,861 }					-- Weltbosse

							-------------------- Warlords of Draenor:  --------------------
	Difficulty[6] = { {1,2,23},{1,2,23},{1,2,23},{1,2,23},{1,2,23},{1,2,23},{1,2,23},{1,2,23},{17,14,15,16},{17,14,15,16},{17,14,15,16},{14} }
	Instanzen[6] = 	{ 547,385,558,536,476,556,559,537,477,457,669,557 }
	MapIDS[6] = 	{ 984,964,987,993,989,1008,995,969,994,988,1026,GL["World Bosses"] }
	Bosse[6][1] = { 1185,1186,1216,1225 }									-- Auchindoun
	Bosse[6][2] = { 893,888,887,889 }										-- Blutschlägermine
	Bosse[6][3] = { 1235,1236,1237,1238 }									-- Eisendocks
	Bosse[6][4] = { 1138,1163,1133 }										-- Grimmgleisdepot
	Bosse[6][5] = { 965,966,967,968 }										-- Himmelsnadel
	Bosse[6][6] = { 1214,1207,1208,1209,1210 }								-- Der Immergrüne Flor
	Bosse[6][7] = { 1226,1227,1228,1229,1234 }								-- Obere Schwarzfelsspitze
	Bosse[6][8] = { 1139,1168,1140,1160 }									-- Schattenmondgrabstätte
							-------------------- Raids:  --------------------
	Bosse[6][9] = { 1128,971,1195,1196,1148,1153,1197 }						-- Hochfels
	Bosse[6][10] = { 1202,1155,1122,1161,1123,1147,1154,1162,1203,959 }		-- Schwarzfelsgießerei
	Bosse[6][11] = { 1426,1425,1392,1432,1396,1372,1433,1427,1391,1447,1394,1395,1438 }		-- Höllenfeuerzitadelle
	Bosse[6][12] = { 1291,1211,1262,1452 }									-- Weltbosse

							-------------------- Legion:  --------------------
	Difficulty[7] = { {23},{1,2,23},{1,2,23},{1,2,23},{23},{1,2,23},--[[{23},]]{1,2,23},{1,2,23},{1,2,23},{1,2,23},{17,14,15,16},--[[{17,14,15,16},]]{17,14,15,16},{0} }
	Instanzen[7] = 	{ 726,716,762,721,800,767,--[[860,]]740,727,777,707,768,--[[861,]]786,822 }
	MapIDS[7] = 	{ 1079,1046,1067,1041,1087,1065,--[[1115,]]1081,GL["Maw of Souls"],1066,1045,1094,--[[1114,]]1088,GL["World Bosses"] }
	Bosse[7][1] = { 1497,1498,1499,1500,1501 }								-- Der Arkus
	Bosse[7][2] = { 1480,1490,1491,1479,1492 }								-- Auge Azsharas
	Bosse[7][3] = { 1654,1655,1656,1657 }									-- Das Finsterherzdickicht
	Bosse[7][4] = { 1485,1486,1487,1488,1489 }								-- Hallen der Tapferkeit
	Bosse[7][5] = { 1718,1719,1720 }										-- Hof der Sterne
	Bosse[7][6] = { 1662,1665,1673,1687 }									-- Neltharions Hort
	-- Bosse[7][7] = { 1820,1826,1827,1825,1835,1837,1836,1817,1818,1838 }		-- Rückkehr nach Karazhan
	Bosse[7][7] = { 1518,1653,1664,1672 }									-- Die Rabenwehr
	Bosse[7][8] = { 1502,1512,1663 }										-- Der Seelenschlund
	Bosse[7][9] = { 1693,1694,1702,1686,1688,1696,1697,1711 }				-- Sturm auf die Violette Festung
	Bosse[7][10] = { 1467,1695,1468,1469,1470 }								-- Das Verlies der Wächterinnen
							-------------------- Raids:  --------------------
	Bosse[7][11] = { 1703,1738,1744,1667,1704,1750,1726 }					-- Smaragdgrüne Alptraum
	-- Bosse[7][13] = { 1819,1830,1829 }										-- Die Prüfung der Tapferkeit
	Bosse[7][12] = { 1706,1725,1731,1751,1762,1713,1761,1732,1743,1737 }	-- Nachtfestung
	Bosse[7][13] = { 1790,1774,1789,1795,1770,1769,1783,1749,1763,1756,1796 }-- Weltbosse

	------------------------------------------------ Fraktionsids für Rufbalken
	FactionDB["Alliance"]["Darnassus"] = 69
	FactionDB["Alliance"]["Exodar"] = 930
	FactionDB["Alliance"]["Gilneas"] = 1134
	FactionDB["Alliance"]["Gnomeregan"] = 54
	FactionDB["Alliance"]["Ironforge"] = 47
	FactionDB["Alliance"]["Stormwind"] = 72 
	FactionDB["Alliance"]["Tushui Pandaren"] = 1353
	FactionDB["Alliance"]["Honor Hold"] = 946
	FactionDB["Alliance"]["Kurenai"] = 978
	FactionDB["Alliance"]["Alliance Vanguard"] = 1037
	FactionDB["Alliance"]["The Silver Covenant"] = 1094
	FactionDB["Alliance"]["Baradin's Wardens"] = 1177
	FactionDB["Alliance"]["Wildhammer Clan"] = 1174
	FactionDB["Alliance"]["Operation: Shieldwall"] = 1376
	FactionDB["Alliance"]["Kirin Tor Offensive"] = 1387
	FactionDB["Alliance"]["Council of Exarchs"] = 1731
	FactionDB["Alliance"]["Hand of the Prophet"] = 1847
	FactionDB["Alliance"]["Sha'tari Defense"] = 1710
	FactionDB["Alliance"]["Wrynn's Vanguard"] = 1682

	FactionDB["Horde"]["Thunder Bluff"] = 81 
	FactionDB["Horde"]["Darkspear Trolls"] = 530
	FactionDB["Horde"]["Orgrimmar"] = 76
	FactionDB["Horde"]["Undercity"] = 68
	FactionDB["Horde"]["Silvermoon City"] = 911
	FactionDB["Horde"]["The Mag'Har"] = 941
	FactionDB["Horde"]["Thrallmar"] = 947
	FactionDB["Horde"]["Tranquillien"] = 922
	FactionDB["Horde"]["The Sunreavers"] = 1124
	FactionDB["Horde"]["Horde Expedition"] = 1052
	FactionDB["Horde"]["Bilgewater Cartel"] = 1133
	FactionDB["Horde"]["Hellscream's Reach"] = 1178
	FactionDB["Horde"]["Dragonmaw Clan"] = 1172
	FactionDB["Horde"]["Huojin Pandaren"] = 1352
	FactionDB["Horde"]["Dominance Offensive"] = 1375
	FactionDB["Horde"]["Sunreaver Onslaught"] =1388
	FactionDB["Horde"]["Frostwolf Orcs"] = 1445
	FactionDB["Horde"]["Laughing Skull Orcs"] =1708
	FactionDB["Horde"]["Vol'jin's Headhunters"] =1848
	FactionDB["Horde"]["Vol'jin's Spear"] = 1681

	Gnoll.Data.Addons = Addons
	Gnoll.Data.ClassSpecs = ClassSpecs

	Gnoll.Data.Instanzen = Instanzen
	Gnoll.Data.MapIDS = MapIDS
	Gnoll.Data.Difficulty = Difficulty
	Gnoll.Data.Bosse = Bosse

	Gnoll.Data.FactionDB = FactionDB
