local _G = _G
local LDB = LibStub("LibDataBroker-1.1", true)
local icon = LibStub("LibDBIcon-1.0")
_G.Gnoll =  {}

local MainMT = {
	__tostring = function(self)
		return AddonNameVersion
	end,
}
setmetatable(_G.Gnoll, MainMT)

function newtable(dim)
    local MT = {};
    for i=1, dim do
        MT[i] = {__index = function(t, k)
            if i < dim then
                t[k] = setmetatable({}, MT[i+1])
                return t[k];
            end
        end}
    end
    return setmetatable({}, MT[1]);
end

_G.Gnoll.Locale = {}
_G.Gnoll.WoWLocale = {}
_G.Gnoll.Data = {} 
_G.Gnoll.DB = {} 
_G.Gnoll.tmp = {} 

local frame = CreateFrame("FRAME")
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGOUT")

function frame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and string.lower(arg1) == "gnoll" then
		local GL = Gnoll.Locale
	
		---Datenbankverwaltung
		if type(GnollDatabase) ~= "table" then -- neue DB anlegen
			ChatFrame1:AddMessage("[Gnoll] Default Database loaded.")
			GnollDatabase = { }
			GnollDatabase["wunschliste"] = { }
			GnollDatabase["wunschliste"][1] = { }
			GnollDatabase["wunschliste"]["names"] = { "Default" }
			GnollDatabase["favoriten"] = {}
			GnollDatabase["opt"] = { }
			GnollDatabase["opt"]["welcome"] = true
			GnollDatabase["opt"]["minimap"] = {}
			GnollDatabase["opt"]["minimap"]["lock"] = false
			GnollDatabase["opt"]["minimap"]["hide"] = false
		 
		else --- Features einzeln adden
			if type(GnollDatabase["wunschliste"]) ~= "table" then
				GnollDatabase["wunschliste"] = {}
				ChatFrame1:AddMessage("[Gnoll] New Feature: Wishlist ")
			end

			if type(GnollDatabase["wunschliste"][1]) ~= "table" then
				local tmp = {}

				for k,v in pairs(GnollDatabase["wunschliste"]) do   
					tmp[k] = v
					--Format anpassen
					tmp[k][5] = tmp[k][4]
					tmp[k][4] = tmp[k][3]
					tmp[k][3] = tmp[k][2]

					if tmp[k][3] > 7 then -- war mal ein Addon
						tmp[k][3] = tmp[k][3] - 7
						tmp[k][2] = "addon"
						
					elseif tmp[k][4] > 24 and tmp[k][3] == 1 then -- war mal ein Modul von Classic
						tmp[k][4] = tmp[k][4] - 24
						tmp[k][2] = "modul"
					elseif tmp[k][4] > 24 and tmp[k][3] == 2 then -- war mal ein Modul von BC
						tmp[k][4] = tmp[k][4] - 24
						tmp[k][2] = "modul"
					elseif tmp[k][4] > 25 and tmp[k][3] == 3 then -- war mal ein Modul von wotlk
						tmp[k][4] = tmp[k][4] - 25
						tmp[k][2] = "modul"
					elseif tmp[k][4] > 20 and tmp[k][3] == 4 then -- war mal ein Modul von cata
						tmp[k][4] = tmp[k][4] - 20
						tmp[k][2] = "modul"
					elseif tmp[k][4] > 15 and tmp[k][3] == 5 then -- war mal ein Modul von mop
						tmp[k][4] = tmp[k][4] - 15
						tmp[k][2] = "modul"
					elseif tmp[k][4] > 12 and tmp[k][3] == 6 then -- war mal ein Modul von wod
						tmp[k][4] = tmp[k][4] - 12
						tmp[k][2] = "modul"
					elseif tmp[k][4] > 13 and tmp[k][3] == 7 then -- war mal ein Modul von legion
						tmp[k][4] = tmp[k][4] - 13
						tmp[k][2] = "modul"
					else
						tmp[k][2] = "default"
					end
				end



				GnollDatabase["wunschliste"] = nil
				GnollDatabase["wunschliste"] = { }
				GnollDatabase["wunschliste"][1] = tmp
				GnollDatabase["wunschliste"]["names"] = { "Default" }

				GnollDatabase["favoriten"] = nil -- reset weil wegen format change
				GnollDatabase["favoriten"] = {}

				ChatFrame1:AddMessage("[Gnoll] New Feature: Multiple Wishlist ")

			end
			
			if type(GnollDatabase["favoriten"]) ~= "table" then
				GnollDatabase["favoriten"] = {}
				ChatFrame1:AddMessage("[Gnoll] New Feature: Favourites ")
			end
			
			if type(GnollDatabase["opt"]) ~= "table" then
				GnollDatabase["opt"] = {}
				GnollDatabase["opt"]["welcome"] = true
				GnollDatabase["opt"]["minimap"] = {}
				GnollDatabase["opt"]["minimap"]["lock"] = false
				GnollDatabase["opt"]["minimap"]["hide"] = false
				ChatFrame1:AddMessage("[Gnoll] New Feature: Options ")
			end

		end
		_G.Gnoll.DB = GnollDatabase
		
		---- Welcome Msgs
		if GnollDatabase["opt"]["welcome"] == true then
			ChatFrame1:AddMessage(GL["Welcome"])
		end

		---- LDB
		local GnollLauncher = LDB:NewDataObject("Gnoll", {
		type = "launcher",
		text = "Gnoll",
		label = "Gnoll",
		icon = "Interface\\Minimap\\tracking\\Banker",
		OnClick = OnClickMinimap,
		OnTooltipShow = function(tt)
			tt:AddLine("|cff00bfffGnoll|r v457")
			tt:AddLine("|cff00bfff"..GL["MapML"])
			tt:AddLine("|cff00bfff"..GL["MapMR"])
		end, })
		
		---- Icon
		icon:Register("Gnoll", GnollLauncher, GnollDatabase["opt"]["minimap"])
		if GnollDatabase["opt"]["minimap"]["lock"] ~= false then
			icon:Lock("Gnoll")
		end
		
		if GnollDatabase["opt"]["minimap"]["hide"] then
			icon:Hide("Gnoll")
		end








		



	end
end
frame:SetScript("OnEvent", frame.OnEvent);

 